//
// SHDesignes CoExec library version 1.4
//
// Copyright 2006-2008 SHDesigns
//
// This code can be used freely and with no cost. The source can not
// be sold without permission from SHDesigns.
//
// please consider donating to support this project
// donations can be made via paypal to rabbit@shdesigns.org
//

#include "..\co_exec.h"
#include <rabbit.h>

extern TASK * _last_task;
extern TASK * _priority_task;

int wait_event(char * eventflag,unsigned long max_time)
{
	if (*eventflag==0)
	{
		_cur_task->event=eventflag;
		sleep(max_time);
	}
	return *eventflag;
}

int set_event(char * eventflag)
{
	char count=0;
	TASK * task=tasks;
	*eventflag=1;
	while (task<=_last_task)
	{
		if (task->event==eventflag)	// task is waiting on event
		{
			task->event=NULL;	// no longer waiting
			task->run=1;
			task->delay=0;
			count++;
			if (!_priority_task)
				_priority_task=task;
		}
		task++;
	}
	return count;
}

void clr_event(char * eventflag)
{
	*eventflag=0;
}
